/* ***********************************************************
 * This file was automatically generated on 2019-09-04.      *
 *                                                           *
 * OpenHAB Bindings Version 2.1.23                           *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;
import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collections;
import java.util.function.Function;
import java.util.function.BiConsumer;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.library.types.OnOffType;
import org.eclipse.smarthome.core.library.types.StringType;

/**
 * 4-channel digital input/output
 */
public class BrickletIO4V2 extends Device {
	public final static int DEVICE_IDENTIFIER = 2111;
	public final static String DEVICE_DISPLAY_NAME = "IO-4 Bricklet 2.0";

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(DEVICE_DISPLAY_NAME, "io4v2", DEVICE_IDENTIFIER, BrickletIO4V2.class);

	public final static byte FUNCTION_SET_VALUE = (byte)1;
	public final static byte FUNCTION_GET_VALUE = (byte)2;
	public final static byte FUNCTION_SET_SELECTED_VALUE = (byte)3;
	public final static byte FUNCTION_SET_CONFIGURATION = (byte)4;
	public final static byte FUNCTION_GET_CONFIGURATION = (byte)5;
	public final static byte FUNCTION_SET_INPUT_VALUE_CALLBACK_CONFIGURATION = (byte)6;
	public final static byte FUNCTION_GET_INPUT_VALUE_CALLBACK_CONFIGURATION = (byte)7;
	public final static byte FUNCTION_SET_ALL_INPUT_VALUE_CALLBACK_CONFIGURATION = (byte)8;
	public final static byte FUNCTION_GET_ALL_INPUT_VALUE_CALLBACK_CONFIGURATION = (byte)9;
	public final static byte FUNCTION_SET_MONOFLOP = (byte)10;
	public final static byte FUNCTION_GET_MONOFLOP = (byte)11;
	public final static byte FUNCTION_GET_EDGE_COUNT = (byte)12;
	public final static byte FUNCTION_SET_EDGE_COUNT_CONFIGURATION = (byte)13;
	public final static byte FUNCTION_GET_EDGE_COUNT_CONFIGURATION = (byte)14;
	public final static byte FUNCTION_SET_PWM_CONFIGURATION = (byte)15;
	public final static byte FUNCTION_GET_PWM_CONFIGURATION = (byte)16;
	public final static byte FUNCTION_GET_SPITFP_ERROR_COUNT = (byte)234;
	public final static byte FUNCTION_SET_BOOTLOADER_MODE = (byte)235;
	public final static byte FUNCTION_GET_BOOTLOADER_MODE = (byte)236;
	public final static byte FUNCTION_SET_WRITE_FIRMWARE_POINTER = (byte)237;
	public final static byte FUNCTION_WRITE_FIRMWARE = (byte)238;
	public final static byte FUNCTION_SET_STATUS_LED_CONFIG = (byte)239;
	public final static byte FUNCTION_GET_STATUS_LED_CONFIG = (byte)240;
	public final static byte FUNCTION_GET_CHIP_TEMPERATURE = (byte)242;
	public final static byte FUNCTION_RESET = (byte)243;
	public final static byte FUNCTION_WRITE_UID = (byte)248;
	public final static byte FUNCTION_READ_UID = (byte)249;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_INPUT_VALUE = 17;
	private final static int CALLBACK_ALL_INPUT_VALUE = 18;
	private final static int CALLBACK_MONOFLOP_DONE = 19;

	public final static char DIRECTION_IN = 'i';
	public final static char DIRECTION_OUT = 'o';
	public final static int EDGE_TYPE_RISING = 0;
	public final static int EDGE_TYPE_FALLING = 1;
	public final static int EDGE_TYPE_BOTH = 2;
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;

	private List<InputValueListener> listenerInputValue = new CopyOnWriteArrayList<InputValueListener>();
	private List<AllInputValueListener> listenerAllInputValue = new CopyOnWriteArrayList<AllInputValueListener>();
	private List<MonoflopDoneListener> listenerMonoflopDone = new CopyOnWriteArrayList<MonoflopDoneListener>();

	public class Configuration {
		public char direction;
		public boolean value;

		public String toString() {
			return "[" + "direction = " + direction + ", " + "value = " + value + "]";
		}
	}

	public class InputValueCallbackConfiguration {
		public long period;
		public boolean valueHasToChange;

		public String toString() {
			return "[" + "period = " + period + ", " + "valueHasToChange = " + valueHasToChange + "]";
		}
	}

	public class AllInputValueCallbackConfiguration {
		public long period;
		public boolean valueHasToChange;

		public String toString() {
			return "[" + "period = " + period + ", " + "valueHasToChange = " + valueHasToChange + "]";
		}
	}

	public class Monoflop {
		public boolean value;
		public long time;
		public long timeRemaining;

		public String toString() {
			return "[" + "value = " + value + ", " + "time = " + time + ", " + "timeRemaining = " + timeRemaining + "]";
		}
	}

	public class EdgeCountConfiguration {
		public int edgeType;
		public int debounce;

		public String toString() {
			return "[" + "edgeType = " + edgeType + ", " + "debounce = " + debounce + "]";
		}
	}

	public class PWMConfiguration {
		public long frequency;
		public int dutyCycle;

		public String toString() {
			return "[" + "frequency = " + frequency + ", " + "dutyCycle = " + dutyCycle + "]";
		}
	}

	public class SPITFPErrorCount {
		public long errorCountAckChecksum;
		public long errorCountMessageChecksum;
		public long errorCountFrame;
		public long errorCountOverflow;

		public String toString() {
			return "[" + "errorCountAckChecksum = " + errorCountAckChecksum + ", " + "errorCountMessageChecksum = " + errorCountMessageChecksum + ", " + "errorCountFrame = " + errorCountFrame + ", " + "errorCountOverflow = " + errorCountOverflow + "]";
		}
	}

	/**
	 * This listener is triggered periodically according to the configuration set by
	 * {@link BrickletIO4V2#setInputValueCallbackConfiguration(int, long, boolean)}.
	 * 
	 * The parameters are the channel, a value-changed indicator and the actual value
	 * for the channel. The `changed` parameter is true if the value has changed since
	 * the last listener.
	 */
	public interface InputValueListener extends DeviceListener {
		public void inputValue(int channel, boolean changed, boolean value);
	}

	/**
	 * This listener is triggered periodically according to the configuration set by
	 * {@link BrickletIO4V2#setAllInputValueCallbackConfiguration(long, boolean)}.
	 * 
	 * The parameters are the same as {@link BrickletIO4V2#getValue()}. Additional the
	 * `changed` parameter is true if the value has changed since
	 * the last listener.
	 */
	public interface AllInputValueListener extends DeviceListener {
		public void allInputValue(boolean[] changed, boolean[] value);
	}

	/**
	 * This listener is triggered whenever a monoflop timer reaches 0. The
	 * parameters contain the channel and the current value of the channel
	 * (the value after the monoflop).
	 */
	public interface MonoflopDoneListener extends DeviceListener {
		public void monoflopDone(int channel, boolean value);
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletIO4V2(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 0;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_VALUE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_VALUE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_SELECTED_VALUE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_INPUT_VALUE_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_INPUT_VALUE_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_ALL_INPUT_VALUE_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_ALL_INPUT_VALUE_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_MONOFLOP)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_MONOFLOP)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_EDGE_COUNT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_EDGE_COUNT_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_EDGE_COUNT_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_PWM_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_PWM_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_SPITFP_ERROR_COUNT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_WRITE_FIRMWARE_POINTER)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_WRITE_FIRMWARE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CHIP_TEMPERATURE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_RESET)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_WRITE_UID)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_READ_UID)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_INPUT_VALUE] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int channel = IPConnection.unsignedByte(bb.get());
				boolean changed = (bb.get()) != 0;
				boolean value = (bb.get()) != 0;

				for (InputValueListener listener: listenerInputValue) {
					listener.inputValue(channel, changed, value);
				}
			}
		};

		callbacks[CALLBACK_ALL_INPUT_VALUE] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				byte[] changedBits = new byte[1];
				bb.get(changedBits);
				boolean[] changed = new boolean[4];
				for (int i = 0; i < 4; i++) {
					changed[i] = (changedBits[i / 8] & (1 << (i % 8))) != 0;
				}

				byte[] valueBits = new byte[1];
				bb.get(valueBits);
				boolean[] value = new boolean[4];
				for (int i = 0; i < 4; i++) {
					value[i] = (valueBits[i / 8] & (1 << (i % 8))) != 0;
				}


				for (AllInputValueListener listener: listenerAllInputValue) {
					listener.allInputValue(changed, value);
				}
			}
		};

		callbacks[CALLBACK_MONOFLOP_DONE] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int channel = IPConnection.unsignedByte(bb.get());
				boolean value = (bb.get()) != 0;

				for (MonoflopDoneListener listener: listenerMonoflopDone) {
					listener.monoflopDone(channel, value);
				}
			}
		};
	}

	/**
	 * Sets the output value of all four channels. A value of *true* or *false* outputs
	 * logic 1 or logic 0 respectively on the corresponding channel.
	 * 
	 * Use {@link BrickletIO4V2#setSelectedValue(int, boolean)} to change only one output channel state.
	 * 
	 * For example: (True, True, False, False) will turn the channels 0-1 high and the
	 * channels 2-3 low.
	 * 
	 * All running monoflop timers and PWMs will be aborted if this function is called.
	 * 
	 * \note
	 *  This function does nothing for channels that are configured as input. Pull-up
	 *  resistors can be switched on with {@link BrickletIO4V2#setConfiguration(int, char, boolean)}.
	 */
	public void setValue(boolean[] value) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_VALUE, this);


		byte[] valueBits = new byte[1];
		Arrays.fill(valueBits, (byte)0);

		for (int i = 0; i < 4; i++) {
			if (value[i]) {
				valueBits[i / 8] |= 1 << (i % 8);
			}
		}
		for (int i = 0; i < 1; i++) {
			bb.put(valueBits[i]);
		}

		sendRequest(bb.array());
	}

	/**
	 * Returns the logic levels that are currently measured on the channels.
	 * This function works if the channel is configured as input as well as if it is
	 * configured as output.
	 */
	public boolean[] getValue() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_VALUE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		byte[] valueBits = new byte[1];
		bb.get(valueBits);
		boolean[] value = new boolean[4];
		for (int i = 0; i < 4; i++) {
			value[i] = (valueBits[i / 8] & (1 << (i % 8))) != 0;
		}


		return value;
	}

	/**
	 * Sets the output value of a specific channel without affecting the other channels.
	 * 
	 * A running monoflop timer or PWM for the specific channel will be aborted if this
	 * function is called.
	 * 
	 * \note
	 *  This function does nothing for channels that are configured as input. Pull-up
	 *  resistors can be switched on with {@link BrickletIO4V2#setConfiguration(int, char, boolean)}.
	 */
	public void setSelectedValue(int channel, boolean value) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_SELECTED_VALUE, this);

		bb.put((byte)channel);
		bb.put((byte)(value ? 1 : 0));

		sendRequest(bb.array());
	}

	/**
	 * Configures the value and direction of a specific channel. Possible directions
	 * are 'i' and 'o' for input and output.
	 * 
	 * If the direction is configured as output, the value is either high or low
	 * (set as *true* or *false*).
	 * 
	 * If the direction is configured as input, the value is either pull-up or
	 * default (set as *true* or *false*).
	 * 
	 * For example:
	 * 
	 * * (0, 'i', true) will set channel 0 as input pull-up.
	 * * (1, 'i', false) will set channel 1 as input default (floating if nothing is connected).
	 * * (2, 'o', true) will set channel 2 as output high.
	 * * (3, 'o', false) will set channel 3 as output low.
	 * 
	 * A running monoflop timer or PWM for the specific channel will be aborted if this
	 * function is called.
	 * 
	 * The default configuration is input with pull-up.
	 */
	public void setConfiguration(int channel, char direction, boolean value) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)11, FUNCTION_SET_CONFIGURATION, this);

		bb.put((byte)channel);
		bb.put((byte)direction);
		bb.put((byte)(value ? 1 : 0));

		sendRequest(bb.array());
	}

	/**
	 * Returns the channel configuration as set by {@link BrickletIO4V2#setConfiguration(int, char, boolean)}.
	 */
	public Configuration getConfiguration(int channel) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_GET_CONFIGURATION, this);

		bb.put((byte)channel);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Configuration obj = new Configuration();
		obj.direction = (char)(bb.get());
		obj.value = (bb.get()) != 0;

		return obj;
	}

	/**
	 * This listener can be configured per channel.
	 * 
	 * The period in ms is the period with which the {@link BrickletIO4V2.InputValueListener}
	 * listener is triggered periodically. A value of 0 turns the listener off.
	 * 
	 * If the `value has to change`-parameter is set to true, the listener is only
	 * triggered after the value has changed. If the value didn't change within the
	 * period, the listener is triggered immediately on change.
	 * 
	 * If it is set to false, the listener is continuously triggered with the period,
	 * independent of the value.
	 * 
	 * The default value is (0, false).
	 */
	public void setInputValueCallbackConfiguration(int channel, long period, boolean valueHasToChange) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)14, FUNCTION_SET_INPUT_VALUE_CALLBACK_CONFIGURATION, this);

		bb.put((byte)channel);
		bb.putInt((int)period);
		bb.put((byte)(valueHasToChange ? 1 : 0));

		sendRequest(bb.array());
	}

	/**
	 * Returns the listener configuration for the given channel as set by
	 * {@link BrickletIO4V2#setInputValueCallbackConfiguration(int, long, boolean)}.
	 */
	public InputValueCallbackConfiguration getInputValueCallbackConfiguration(int channel) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_GET_INPUT_VALUE_CALLBACK_CONFIGURATION, this);

		bb.put((byte)channel);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		InputValueCallbackConfiguration obj = new InputValueCallbackConfiguration();
		obj.period = IPConnection.unsignedInt(bb.getInt());
		obj.valueHasToChange = (bb.get()) != 0;

		return obj;
	}

	/**
	 * The period in ms is the period with which the {@link BrickletIO4V2.AllInputValueListener}
	 * listener is triggered periodically. A value of 0 turns the listener off.
	 * 
	 * If the `value has to change`-parameter is set to true, the listener is only
	 * triggered after the value has changed. If the value didn't change within the
	 * period, the listener is triggered immediately on change.
	 * 
	 * If it is set to false, the listener is continuously triggered with the period,
	 * independent of the value.
	 * 
	 * The default value is (0, false).
	 */
	public void setAllInputValueCallbackConfiguration(long period, boolean valueHasToChange) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)13, FUNCTION_SET_ALL_INPUT_VALUE_CALLBACK_CONFIGURATION, this);

		bb.putInt((int)period);
		bb.put((byte)(valueHasToChange ? 1 : 0));

		sendRequest(bb.array());
	}

	/**
	 * Returns the listener configuration as set by
	 * {@link BrickletIO4V2#setAllInputValueCallbackConfiguration(long, boolean)}.
	 */
	public AllInputValueCallbackConfiguration getAllInputValueCallbackConfiguration() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_ALL_INPUT_VALUE_CALLBACK_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		AllInputValueCallbackConfiguration obj = new AllInputValueCallbackConfiguration();
		obj.period = IPConnection.unsignedInt(bb.getInt());
		obj.valueHasToChange = (bb.get()) != 0;

		return obj;
	}

	/**
	 * The first parameter is the desired state of the channel (*true* means output *high*
	 * and *false* means output *low*). The second parameter indicates the time (in ms) that
	 * the channel should hold the state.
	 * 
	 * If this function is called with the parameters (true, 1500):
	 * The channel will turn on and in 1.5s it will turn off again.
	 * 
	 * A PWM for the selected channel will be aborted if this function is called.
	 * 
	 * A monoflop can be used as a failsafe mechanism. For example: Lets assume you
	 * have a RS485 bus and a IO-4 Bricklet 2.0 is connected to one of the slave
	 * stacks. You can now call this function every second, with a time parameter
	 * of two seconds. The channel will be *high* all the time. If now the RS485
	 * connection is lost, the channel will turn *low* in at most two seconds.
	 */
	public void setMonoflop(int channel, boolean value, long time) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)14, FUNCTION_SET_MONOFLOP, this);

		bb.put((byte)channel);
		bb.put((byte)(value ? 1 : 0));
		bb.putInt((int)time);

		sendRequest(bb.array());
	}

	/**
	 * Returns (for the given channel) the current value and the time as set by
	 * {@link BrickletIO4V2#setMonoflop(int, boolean, long)} as well as the remaining time until the value flips.
	 * 
	 * If the timer is not running currently, the remaining time will be returned
	 * as 0.
	 */
	public Monoflop getMonoflop(int channel) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_GET_MONOFLOP, this);

		bb.put((byte)channel);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Monoflop obj = new Monoflop();
		obj.value = (bb.get()) != 0;
		obj.time = IPConnection.unsignedInt(bb.getInt());
		obj.timeRemaining = IPConnection.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Returns the current value of the edge counter for the selected channel. You can
	 * configure the edges that are counted with {@link BrickletIO4V2#setEdgeCountConfiguration(int, int, int)}.
	 * 
	 * If you set the reset counter to *true*, the count is set back to 0
	 * directly after it is read.
	 */
	public long getEdgeCount(int channel, boolean resetCounter) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_GET_EDGE_COUNT, this);

		bb.put((byte)channel);
		bb.put((byte)(resetCounter ? 1 : 0));

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long count = IPConnection.unsignedInt(bb.getInt());

		return count;
	}

	/**
	 * Configures the edge counter for a specific channel.
	 * 
	 * The edge type parameter configures if rising edges, falling edges or
	 * both are counted if the channel is configured for input. Possible edge types are:
	 * 
	 * * 0 = rising (default)
	 * * 1 = falling
	 * * 2 = both
	 * 
	 * The debounce time is given in ms.
	 * 
	 * Configuring an edge counter resets its value to 0.
	 * 
	 * If you don't know what any of this means, just leave it at default. The
	 * default configuration is very likely OK for you.
	 * 
	 * Default values: 0 (edge type) and 100ms (debounce time)
	 */
	public void setEdgeCountConfiguration(int channel, int edgeType, int debounce) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)11, FUNCTION_SET_EDGE_COUNT_CONFIGURATION, this);

		bb.put((byte)channel);
		bb.put((byte)edgeType);
		bb.put((byte)debounce);

		sendRequest(bb.array());
	}

	/**
	 * Returns the edge type and debounce time for the selected channel as set by
	 * {@link BrickletIO4V2#setEdgeCountConfiguration(int, int, int)}.
	 */
	public EdgeCountConfiguration getEdgeCountConfiguration(int channel) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_GET_EDGE_COUNT_CONFIGURATION, this);

		bb.put((byte)channel);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		EdgeCountConfiguration obj = new EdgeCountConfiguration();
		obj.edgeType = IPConnection.unsignedByte(bb.get());
		obj.debounce = IPConnection.unsignedByte(bb.get());

		return obj;
	}

	/**
	 * Activates a PWM for the given channel with the frequency given in 1/10Hz and the duty
	 * cycle given in 1/100%.
	 * 
	 * You need to set the channel to output before you call this function, otherwise it will
	 * be ignored. To turn the PWM off again, you can set the frequency to 0 or any other
	 * function that changes a value of the channel (e.g. {@link BrickletIO4V2#setSelectedValue(int, boolean)}).
	 * 
	 * The maximum frequency value is 320000000 (32MHz). The maximum duty cycle value is
	 * 10000 (100%).
	 * 
	 * A running monoflop timer for the given channel will be aborted if this function
	 * is called.
	 * 
	 * The default values are 0, 0.
	 */
	public void setPWMConfiguration(int channel, long frequency, int dutyCycle) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)15, FUNCTION_SET_PWM_CONFIGURATION, this);

		bb.put((byte)channel);
		bb.putInt((int)frequency);
		bb.putShort((short)dutyCycle);

		sendRequest(bb.array());
	}

	/**
	 * Returns the PWM configuration as set by {@link BrickletIO4V2#setPWMConfiguration(int, long, int)}.
	 */
	public PWMConfiguration getPWMConfiguration(int channel) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_GET_PWM_CONFIGURATION, this);

		bb.put((byte)channel);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		PWMConfiguration obj = new PWMConfiguration();
		obj.frequency = IPConnection.unsignedInt(bb.getInt());
		obj.dutyCycle = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Returns the error count for the communication between Brick and Bricklet.
	 * 
	 * The errors are divided into
	 * 
	 * * ACK checksum errors,
	 * * message checksum errors,
	 * * framing errors and
	 * * overflow errors.
	 * 
	 * The errors counts are for errors that occur on the Bricklet side. All
	 * Bricks have a similar function that returns the errors on the Brick side.
	 */
	public SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_SPITFP_ERROR_COUNT, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		SPITFPErrorCount obj = new SPITFPErrorCount();
		obj.errorCountAckChecksum = IPConnection.unsignedInt(bb.getInt());
		obj.errorCountMessageChecksum = IPConnection.unsignedInt(bb.getInt());
		obj.errorCountFrame = IPConnection.unsignedInt(bb.getInt());
		obj.errorCountOverflow = IPConnection.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Sets the bootloader mode and returns the status after the requested
	 * mode change was instigated.
	 * 
	 * You can change from bootloader mode to firmware mode and vice versa. A change
	 * from bootloader mode to firmware mode will only take place if the entry function,
	 * device identifier and CRC are present and correct.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int setBootloaderMode(int mode) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_BOOTLOADER_MODE, this);

		bb.put((byte)mode);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnection.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Returns the current bootloader mode, see {@link BrickletIO4V2#setBootloaderMode(int)}.
	 */
	public int getBootloaderMode() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_BOOTLOADER_MODE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int mode = IPConnection.unsignedByte(bb.get());

		return mode;
	}

	/**
	 * Sets the firmware pointer for {@link BrickletIO4V2#writeFirmware(int[])}. The pointer has
	 * to be increased by chunks of size 64. The data is written to flash
	 * every 4 chunks (which equals to one page of size 256).
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_WRITE_FIRMWARE_POINTER, this);

		bb.putInt((int)pointer);

		sendRequest(bb.array());
	}

	/**
	 * Writes 64 Bytes of firmware at the position as written by
	 * {@link BrickletIO4V2#setWriteFirmwarePointer(long)} before. The firmware is written
	 * to flash every 4 chunks.
	 * 
	 * You can only write firmware in bootloader mode.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int writeFirmware(int[] data) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)72, FUNCTION_WRITE_FIRMWARE, this);

		for (int i = 0; i < 64; i++) {
			bb.put((byte)data[i]);
		}

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnection.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Sets the status LED configuration. By default the LED shows
	 * communication traffic between Brick and Bricklet, it flickers once
	 * for every 10 received data packets.
	 * 
	 * You can also turn the LED permanently on/off or show a heartbeat.
	 * 
	 * If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
	 */
	public void setStatusLEDConfig(int config) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_STATUS_LED_CONFIG, this);

		bb.put((byte)config);

		sendRequest(bb.array());
	}

	/**
	 * Returns the configuration as set by {@link BrickletIO4V2#setStatusLEDConfig(int)}
	 */
	public int getStatusLEDConfig() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_STATUS_LED_CONFIG, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int config = IPConnection.unsignedByte(bb.get());

		return config;
	}

	/**
	 * Returns the temperature in °C as measured inside the microcontroller. The
	 * value returned is not the ambient temperature!
	 * 
	 * The temperature is only proportional to the real temperature and it has bad
	 * accuracy. Practically it is only useful as an indicator for
	 * temperature changes.
	 */
	public int getChipTemperature() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CHIP_TEMPERATURE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int temperature = (bb.getShort());

		return temperature;
	}

	/**
	 * Calling this function will reset the Bricklet. All configurations
	 * will be lost.
	 * 
	 * After a reset you have to create new device objects,
	 * calling functions on the existing ones will result in
	 * undefined behavior!
	 */
	public void reset() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_RESET, this);


		sendRequest(bb.array());
	}

	/**
	 * Writes a new UID into flash. If you want to set a new UID
	 * you have to decode the Base58 encoded UID string into an
	 * integer first.
	 * 
	 * We recommend that you use Brick Viewer to change the UID.
	 */
	public void writeUID(long uid) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_WRITE_UID, this);

		bb.putInt((int)uid);

		sendRequest(bb.array());
	}

	/**
	 * Returns the current UID as an integer. Encode as
	 * Base58 to get the usual string version.
	 */
	public long readUID() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_READ_UID, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long uid = IPConnection.unsignedInt(bb.getInt());

		return uid;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c' or 'd'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnection.string(bb, 8);
		obj.connectedUid = IPConnection.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Adds a InputValue listener.
	 */
	public void addInputValueListener(InputValueListener listener) {
		listenerInputValue.add(listener);
	}

	/**
	 * Removes a InputValue listener.
	 */
	public void removeInputValueListener(InputValueListener listener) {
		listenerInputValue.remove(listener);
	}

	/**
	 * Adds a AllInputValue listener.
	 */
	public void addAllInputValueListener(AllInputValueListener listener) {
		listenerAllInputValue.add(listener);
	}

	/**
	 * Removes a AllInputValue listener.
	 */
	public void removeAllInputValueListener(AllInputValueListener listener) {
		listenerAllInputValue.remove(listener);
	}

	/**
	 * Adds a MonoflopDone listener.
	 */
	public void addMonoflopDoneListener(MonoflopDoneListener listener) {
		listenerMonoflopDone.add(listener);
	}

	/**
	 * Removes a MonoflopDone listener.
	 */
	public void removeMonoflopDoneListener(MonoflopDoneListener listener) {
		listenerMonoflopDone.remove(listener);
	}

    private final Logger logger = LoggerFactory.getLogger(BrickletIO4V2.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletIO4V2.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletIO4V2Config cfg = (BrickletIO4V2Config) config.as(BrickletIO4V2Config.class);
        this.addInputValueListener((channel, changed, value) -> {if(channel == 0) {updateStateFn.accept("IO4V2InputPin0", transformIO4V2InputPin0Callback0(channel, changed, value, cfg));}});
		this.addInputValueListener((channel, changed, value) -> {if(channel == 1) {updateStateFn.accept("IO4V2InputPin1", transformIO4V2InputPin1Callback0(channel, changed, value, cfg));}});
		this.addInputValueListener((channel, changed, value) -> {if(channel == 2) {updateStateFn.accept("IO4V2InputPin2", transformIO4V2InputPin2Callback0(channel, changed, value, cfg));}});
		this.addInputValueListener((channel, changed, value) -> {if(channel == 3) {updateStateFn.accept("IO4V2InputPin3", transformIO4V2InputPin3Callback0(channel, changed, value, cfg));}});
		this.addMonoflopDoneListener((channel, value) -> {if(channel == 0) {updateStateFn.accept("IO4V2OutputPin0", transformIO4V2OutputPin0Callback0(channel, value, cfg));}});
		this.addMonoflopDoneListener((channel, value) -> {if(channel == 1) {updateStateFn.accept("IO4V2OutputPin1", transformIO4V2OutputPin1Callback0(channel, value, cfg));}});
		this.addMonoflopDoneListener((channel, value) -> {if(channel == 2) {updateStateFn.accept("IO4V2OutputPin2", transformIO4V2OutputPin2Callback0(channel, value, cfg));}});
		this.addMonoflopDoneListener((channel, value) -> {if(channel == 3) {updateStateFn.accept("IO4V2OutputPin3", transformIO4V2OutputPin3Callback0(channel, value, cfg));}});
        
		if (cfg.pinConfiguration0 > 1) {
		BrickletIO4V2InputPinConfig channelCfg = getChannelConfigFn.apply("IO4V2InputPin0").as(BrickletIO4V2InputPinConfig.class);
		this.setConfiguration(0, 'i', cfg.pinConfiguration0 % 2 == 1);
		            this.setInputValueCallbackConfiguration(0, 1000, false);
		}
		if (cfg.pinConfiguration1 > 1) {
		BrickletIO4V2InputPinConfig channelCfg = getChannelConfigFn.apply("IO4V2InputPin1").as(BrickletIO4V2InputPinConfig.class);
		this.setConfiguration(1, 'i', cfg.pinConfiguration1 % 2 == 1);
		            this.setInputValueCallbackConfiguration(1, 1000, false);
		}
		if (cfg.pinConfiguration2 > 1) {
		BrickletIO4V2InputPinConfig channelCfg = getChannelConfigFn.apply("IO4V2InputPin2").as(BrickletIO4V2InputPinConfig.class);
		this.setConfiguration(2, 'i', cfg.pinConfiguration2 % 2 == 1);
		            this.setInputValueCallbackConfiguration(2, 1000, false);
		}
		if (cfg.pinConfiguration3 > 1) {
		BrickletIO4V2InputPinConfig channelCfg = getChannelConfigFn.apply("IO4V2InputPin3").as(BrickletIO4V2InputPinConfig.class);
		this.setConfiguration(3, 'i', cfg.pinConfiguration3 % 2 == 1);
		            this.setInputValueCallbackConfiguration(3, 1000, false);
		}
		if (cfg.pinConfiguration0 <= 1) {
		BrickletIO4V2OutputPinConfig channelCfg = getChannelConfigFn.apply("IO4V2OutputPin0").as(BrickletIO4V2OutputPinConfig.class);
		this.setConfiguration(0, 'o', cfg.pinConfiguration0 % 2 == 1);
		}
		if (cfg.pinConfiguration1 <= 1) {
		BrickletIO4V2OutputPinConfig channelCfg = getChannelConfigFn.apply("IO4V2OutputPin1").as(BrickletIO4V2OutputPinConfig.class);
		this.setConfiguration(1, 'o', cfg.pinConfiguration1 % 2 == 1);
		}
		if (cfg.pinConfiguration2 <= 1) {
		BrickletIO4V2OutputPinConfig channelCfg = getChannelConfigFn.apply("IO4V2OutputPin2").as(BrickletIO4V2OutputPinConfig.class);
		this.setConfiguration(2, 'o', cfg.pinConfiguration2 % 2 == 1);
		}
		if (cfg.pinConfiguration3 <= 1) {
		BrickletIO4V2OutputPinConfig channelCfg = getChannelConfigFn.apply("IO4V2OutputPin3").as(BrickletIO4V2OutputPinConfig.class);
		this.setConfiguration(3, 'o', cfg.pinConfiguration3 % 2 == 1);
		}
		if (cfg.pinConfiguration0 <= 1) {
		BrickletIO4V2MonoflopConfig channelCfg = getChannelConfigFn.apply("IO4V2MonoflopPin0").as(BrickletIO4V2MonoflopConfig.class);
		
		}
		if (cfg.pinConfiguration1 <= 1) {
		BrickletIO4V2MonoflopConfig channelCfg = getChannelConfigFn.apply("IO4V2MonoflopPin1").as(BrickletIO4V2MonoflopConfig.class);
		
		}
		if (cfg.pinConfiguration2 <= 1) {
		BrickletIO4V2MonoflopConfig channelCfg = getChannelConfigFn.apply("IO4V2MonoflopPin2").as(BrickletIO4V2MonoflopConfig.class);
		
		}
		if (cfg.pinConfiguration3 <= 1) {
		BrickletIO4V2MonoflopConfig channelCfg = getChannelConfigFn.apply("IO4V2MonoflopPin3").as(BrickletIO4V2MonoflopConfig.class);
		
		}
		if (cfg.pinConfiguration0 > 1) {
		BrickletIO4V2EdgeCountConfig channelCfg = getChannelConfigFn.apply("IO4V2EdgeCountPin0").as(BrickletIO4V2EdgeCountConfig.class);
		this.setEdgeCountConfiguration(0, channelCfg.edgeType, channelCfg.debounce);
		}
		if (cfg.pinConfiguration1 > 1) {
		BrickletIO4V2EdgeCountConfig channelCfg = getChannelConfigFn.apply("IO4V2EdgeCountPin1").as(BrickletIO4V2EdgeCountConfig.class);
		this.setEdgeCountConfiguration(1, channelCfg.edgeType, channelCfg.debounce);
		}
		if (cfg.pinConfiguration2 > 1) {
		BrickletIO4V2EdgeCountConfig channelCfg = getChannelConfigFn.apply("IO4V2EdgeCountPin2").as(BrickletIO4V2EdgeCountConfig.class);
		this.setEdgeCountConfiguration(2, channelCfg.edgeType, channelCfg.debounce);
		}
		if (cfg.pinConfiguration3 > 1) {
		BrickletIO4V2EdgeCountConfig channelCfg = getChannelConfigFn.apply("IO4V2EdgeCountPin3").as(BrickletIO4V2EdgeCountConfig.class);
		this.setEdgeCountConfiguration(3, channelCfg.edgeType, channelCfg.debounce);
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        BrickletIO4V2Config cfg = (BrickletIO4V2Config) config.as(BrickletIO4V2Config.class);
        this.listenerInputValue.clear();
		this.listenerInputValue.clear();
		this.listenerInputValue.clear();
		this.listenerInputValue.clear();
		this.listenerMonoflopDone.clear();
		this.listenerMonoflopDone.clear();
		this.listenerMonoflopDone.clear();
		this.listenerMonoflopDone.clear();
        this.setInputValueCallbackConfiguration(0, 0, false);
		this.setInputValueCallbackConfiguration(1, 0, false);
		this.setInputValueCallbackConfiguration(2, 0, false);
		this.setInputValueCallbackConfiguration(3, 0, false);
		
		
		
		
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletIO4V2Config cfg = (BrickletIO4V2Config) config.as(BrickletIO4V2Config.class);
        List<String> result = new ArrayList<String>();
        if (cfg.pinConfiguration0 > 1) {
                result.add("IO4V2InputPin0");
            }
		if (cfg.pinConfiguration1 > 1) {
                result.add("IO4V2InputPin1");
            }
		if (cfg.pinConfiguration2 > 1) {
                result.add("IO4V2InputPin2");
            }
		if (cfg.pinConfiguration3 > 1) {
                result.add("IO4V2InputPin3");
            }
		if (cfg.pinConfiguration0 <= 1) {
                result.add("IO4V2OutputPin0");
            }
		if (cfg.pinConfiguration1 <= 1) {
                result.add("IO4V2OutputPin1");
            }
		if (cfg.pinConfiguration2 <= 1) {
                result.add("IO4V2OutputPin2");
            }
		if (cfg.pinConfiguration3 <= 1) {
                result.add("IO4V2OutputPin3");
            }
		if (cfg.pinConfiguration0 <= 1) {
                result.add("IO4V2MonoflopPin0");
            }
		if (cfg.pinConfiguration1 <= 1) {
                result.add("IO4V2MonoflopPin1");
            }
		if (cfg.pinConfiguration2 <= 1) {
                result.add("IO4V2MonoflopPin2");
            }
		if (cfg.pinConfiguration3 <= 1) {
                result.add("IO4V2MonoflopPin3");
            }
		if (cfg.pinConfiguration0 > 1) {
                result.add("IO4V2EdgeCountPin0");
            }
		if (cfg.pinConfiguration1 > 1) {
                result.add("IO4V2EdgeCountPin1");
            }
		if (cfg.pinConfiguration2 > 1) {
                result.add("IO4V2EdgeCountPin2");
            }
		if (cfg.pinConfiguration3 > 1) {
                result.add("IO4V2EdgeCountPin3");
            }
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "IO4V2InputPin":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "IO4V2InputPin"), "Measured Level", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:IO4V2InputPin")).withDescription("The logic level that is currently measured on the pin.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(true).build().toStateDescription()).build();
            case "IO4V2OutputPin":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "IO4V2OutputPin"), "Set Level", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:IO4V2OutputPin")).withDescription("The logic level that is currently set on the pin.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(false).build().toStateDescription()).build();
            case "IO4V2Monoflop":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "IO4V2Monoflop"), "NOT USED", "String").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:IO4V2Monoflop")).withDescription("Triggers a monoflop as configured")
.withCommandDescription(CommandDescriptionBuilder.create().withCommandOption(new CommandOption("TRIGGER", "Trigger")).build()).build();
            case "IO4V2EdgeCount":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "IO4V2EdgeCount"), "Edge Count", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:IO4V2EdgeCount")).withDescription("The current value of the edge counter for the selected channel")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge IO-4 Bricklet 2.0").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.getId())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("4-channel digital input/output").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("IO4V2InputPin0", new ChannelTypeUID("tinkerforge", "IO4V2InputPin")).withLabel("Measured Level (Pin 0)").build(), new ChannelDefinitionBuilder("IO4V2InputPin1", new ChannelTypeUID("tinkerforge", "IO4V2InputPin")).withLabel("Measured Level (Pin 1)").build(), new ChannelDefinitionBuilder("IO4V2InputPin2", new ChannelTypeUID("tinkerforge", "IO4V2InputPin")).withLabel("Measured Level (Pin 2)").build(), new ChannelDefinitionBuilder("IO4V2InputPin3", new ChannelTypeUID("tinkerforge", "IO4V2InputPin")).withLabel("Measured Level (Pin 3)").build(), new ChannelDefinitionBuilder("IO4V2OutputPin0", new ChannelTypeUID("tinkerforge", "IO4V2OutputPin")).withLabel("Set Level (Pin 0)").build(), new ChannelDefinitionBuilder("IO4V2OutputPin1", new ChannelTypeUID("tinkerforge", "IO4V2OutputPin")).withLabel("Set Level (Pin 1)").build(), new ChannelDefinitionBuilder("IO4V2OutputPin2", new ChannelTypeUID("tinkerforge", "IO4V2OutputPin")).withLabel("Set Level (Pin 2)").build(), new ChannelDefinitionBuilder("IO4V2OutputPin3", new ChannelTypeUID("tinkerforge", "IO4V2OutputPin")).withLabel("Set Level (Pin 3)").build(), new ChannelDefinitionBuilder("IO4V2MonoflopPin0", new ChannelTypeUID("tinkerforge", "IO4V2Monoflop")).withLabel("Monoflop Pin 0").build(), new ChannelDefinitionBuilder("IO4V2MonoflopPin1", new ChannelTypeUID("tinkerforge", "IO4V2Monoflop")).withLabel("Monoflop Pin 1").build(), new ChannelDefinitionBuilder("IO4V2MonoflopPin2", new ChannelTypeUID("tinkerforge", "IO4V2Monoflop")).withLabel("Monoflop Pin 2").build(), new ChannelDefinitionBuilder("IO4V2MonoflopPin3", new ChannelTypeUID("tinkerforge", "IO4V2Monoflop")).withLabel("Monoflop Pin 3").build(), new ChannelDefinitionBuilder("IO4V2EdgeCountPin0", new ChannelTypeUID("tinkerforge", "IO4V2EdgeCount")).withLabel("Edge Count Pin 0").build(), new ChannelDefinitionBuilder("IO4V2EdgeCountPin1", new ChannelTypeUID("tinkerforge", "IO4V2EdgeCount")).withLabel("Edge Count Pin 1").build(), new ChannelDefinitionBuilder("IO4V2EdgeCountPin2", new ChannelTypeUID("tinkerforge", "IO4V2EdgeCount")).withLabel("Edge Count Pin 2").build(), new ChannelDefinitionBuilder("IO4V2EdgeCountPin3", new ChannelTypeUID("tinkerforge", "IO4V2EdgeCount")).withLabel("Edge Count Pin 3").build())).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:io4v2":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("pinConfiguration0", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 0. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 0").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration1", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 1. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 1").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration2", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 2. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 2").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration3", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 3. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 3").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build()));
            case "channel-type:tinkerforge:IO4V2InputPin":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build()));
            case "channel-type:tinkerforge:IO4V2OutputPin":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build()));
            case "channel-type:tinkerforge:IO4V2Monoflop":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("monoflopDuration", Type.INTEGER).withDefault("1000").withDescription("The time (in ms) that the pin should hold the configured value.").withLabel("Monoflop duration").withUnit("ms").withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(2147483647)).build(), ConfigDescriptionParameterBuilder.create("monoflopValue", Type.BOOLEAN).withDefault("true").withDescription("The desired value of the specified channel. Activated means relay closed and Deactivated means relay open.").withLabel("Monoflop value").build()));
            case "channel-type:tinkerforge:IO4V2EdgeCount":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build(), ConfigDescriptionParameterBuilder.create("edgeType", Type.INTEGER).withDefault("0").withDescription("The edge type parameter configures if rising edges, falling edges or both are counted.").withLabel("Edge Type").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Rising"), new ParameterOption("1", "Falling"), new ParameterOption("2", "Both"))).build(), ConfigDescriptionParameterBuilder.create("debounce", Type.INTEGER).withDefault("100").withDescription("The debounce time in ms.").withLabel("Debounce Time").build(), ConfigDescriptionParameterBuilder.create("resetOnRead", Type.BOOLEAN).withDefault("false").withDescription("Enabling this will reset the edge counter after OpenHAB reads its value. Use this if you want relative edge counts per update.").withLabel("Reset Edge Count on Update").build()));
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String value, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletIO4V2Config cfg = (BrickletIO4V2Config) config.as(BrickletIO4V2Config.class);
        switch(value) {
            case "IO4V2InputPin0": {
                   BrickletIO4V2InputPinConfig channelCfg = channelConfig.as(BrickletIO4V2InputPinConfig.class);
                   updateStateFn.accept(value, transformIO4V2InputPin0Getter0(this.getValue(), cfg));
                   return;
               }
            case "IO4V2InputPin1": {
                   BrickletIO4V2InputPinConfig channelCfg = channelConfig.as(BrickletIO4V2InputPinConfig.class);
                   updateStateFn.accept(value, transformIO4V2InputPin1Getter0(this.getValue(), cfg));
                   return;
               }
            case "IO4V2InputPin2": {
                   BrickletIO4V2InputPinConfig channelCfg = channelConfig.as(BrickletIO4V2InputPinConfig.class);
                   updateStateFn.accept(value, transformIO4V2InputPin2Getter0(this.getValue(), cfg));
                   return;
               }
            case "IO4V2InputPin3": {
                   BrickletIO4V2InputPinConfig channelCfg = channelConfig.as(BrickletIO4V2InputPinConfig.class);
                   updateStateFn.accept(value, transformIO4V2InputPin3Getter0(this.getValue(), cfg));
                   return;
               }
            case "IO4V2OutputPin0": {
                   BrickletIO4V2OutputPinConfig channelCfg = channelConfig.as(BrickletIO4V2OutputPinConfig.class);
                   updateStateFn.accept(value, transformIO4V2OutputPin0Getter0(this.getValue(), cfg));
                   return;
               }
            case "IO4V2OutputPin1": {
                   BrickletIO4V2OutputPinConfig channelCfg = channelConfig.as(BrickletIO4V2OutputPinConfig.class);
                   updateStateFn.accept(value, transformIO4V2OutputPin1Getter0(this.getValue(), cfg));
                   return;
               }
            case "IO4V2OutputPin2": {
                   BrickletIO4V2OutputPinConfig channelCfg = channelConfig.as(BrickletIO4V2OutputPinConfig.class);
                   updateStateFn.accept(value, transformIO4V2OutputPin2Getter0(this.getValue(), cfg));
                   return;
               }
            case "IO4V2OutputPin3": {
                   BrickletIO4V2OutputPinConfig channelCfg = channelConfig.as(BrickletIO4V2OutputPinConfig.class);
                   updateStateFn.accept(value, transformIO4V2OutputPin3Getter0(this.getValue(), cfg));
                   return;
               }
            case "IO4V2MonoflopPin0": {
                   BrickletIO4V2MonoflopConfig channelCfg = channelConfig.as(BrickletIO4V2MonoflopConfig.class);
                   updateStateFn.accept(value, transformIO4V2MonoflopPin0Getter0(this.getMonoflop(0), cfg));
                   return;
               }
            case "IO4V2MonoflopPin1": {
                   BrickletIO4V2MonoflopConfig channelCfg = channelConfig.as(BrickletIO4V2MonoflopConfig.class);
                   updateStateFn.accept(value, transformIO4V2MonoflopPin1Getter0(this.getMonoflop(1), cfg));
                   return;
               }
            case "IO4V2MonoflopPin2": {
                   BrickletIO4V2MonoflopConfig channelCfg = channelConfig.as(BrickletIO4V2MonoflopConfig.class);
                   updateStateFn.accept(value, transformIO4V2MonoflopPin2Getter0(this.getMonoflop(2), cfg));
                   return;
               }
            case "IO4V2MonoflopPin3": {
                   BrickletIO4V2MonoflopConfig channelCfg = channelConfig.as(BrickletIO4V2MonoflopConfig.class);
                   updateStateFn.accept(value, transformIO4V2MonoflopPin3Getter0(this.getMonoflop(3), cfg));
                   return;
               }
            case "IO4V2EdgeCountPin0": {
                   BrickletIO4V2EdgeCountConfig channelCfg = channelConfig.as(BrickletIO4V2EdgeCountConfig.class);
                   updateStateFn.accept(value, transformIO4V2EdgeCountPin0Getter0(this.getEdgeCount(0, channelCfg.resetOnRead), cfg));
                   return;
               }
            case "IO4V2EdgeCountPin1": {
                   BrickletIO4V2EdgeCountConfig channelCfg = channelConfig.as(BrickletIO4V2EdgeCountConfig.class);
                   updateStateFn.accept(value, transformIO4V2EdgeCountPin1Getter0(this.getEdgeCount(1, channelCfg.resetOnRead), cfg));
                   return;
               }
            case "IO4V2EdgeCountPin2": {
                   BrickletIO4V2EdgeCountConfig channelCfg = channelConfig.as(BrickletIO4V2EdgeCountConfig.class);
                   updateStateFn.accept(value, transformIO4V2EdgeCountPin2Getter0(this.getEdgeCount(2, channelCfg.resetOnRead), cfg));
                   return;
               }
            case "IO4V2EdgeCountPin3": {
                   BrickletIO4V2EdgeCountConfig channelCfg = channelConfig.as(BrickletIO4V2EdgeCountConfig.class);
                   updateStateFn.accept(value, transformIO4V2EdgeCountPin3Getter0(this.getEdgeCount(3, channelCfg.resetOnRead), cfg));
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", value);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = new ArrayList<SetterRefresh>();
        BrickletIO4V2Config cfg = (BrickletIO4V2Config) config.as(BrickletIO4V2Config.class);
        switch(channel) {
            case "IO4V2OutputPin0":
                if (command instanceof OnOffType) {
                    BrickletIO4V2OutputPinConfig channelCfg = channelConfig.as(BrickletIO4V2OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValue(0, cmd == OnOffType.ON);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IO4V2OutputPin1":
                if (command instanceof OnOffType) {
                    BrickletIO4V2OutputPinConfig channelCfg = channelConfig.as(BrickletIO4V2OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValue(1, cmd == OnOffType.ON);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IO4V2OutputPin2":
                if (command instanceof OnOffType) {
                    BrickletIO4V2OutputPinConfig channelCfg = channelConfig.as(BrickletIO4V2OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValue(2, cmd == OnOffType.ON);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IO4V2OutputPin3":
                if (command instanceof OnOffType) {
                    BrickletIO4V2OutputPinConfig channelCfg = channelConfig.as(BrickletIO4V2OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValue(3, cmd == OnOffType.ON);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IO4V2MonoflopPin0":
                if (command instanceof StringType) {
                    BrickletIO4V2MonoflopConfig channelCfg = channelConfig.as(BrickletIO4V2MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop(0, channelCfg.monoflopValue.booleanValue(), channelCfg.monoflopDuration);
                    result.add(new SetterRefresh("IO4V2OutputPin0", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            case "IO4V2MonoflopPin1":
                if (command instanceof StringType) {
                    BrickletIO4V2MonoflopConfig channelCfg = channelConfig.as(BrickletIO4V2MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop(1, channelCfg.monoflopValue.booleanValue(), channelCfg.monoflopDuration);
                    result.add(new SetterRefresh("IO4V2OutputPin1", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            case "IO4V2MonoflopPin2":
                if (command instanceof StringType) {
                    BrickletIO4V2MonoflopConfig channelCfg = channelConfig.as(BrickletIO4V2MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop(2, channelCfg.monoflopValue.booleanValue(), channelCfg.monoflopDuration);
                    result.add(new SetterRefresh("IO4V2OutputPin2", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            case "IO4V2MonoflopPin3":
                if (command instanceof StringType) {
                    BrickletIO4V2MonoflopConfig channelCfg = channelConfig.as(BrickletIO4V2MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop(3, channelCfg.monoflopValue.booleanValue(), channelCfg.monoflopDuration);
                    result.add(new SetterRefresh("IO4V2OutputPin3", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformIO4V2InputPin0Callback0(int channel, boolean changed, boolean value, BrickletIO4V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO4V2InputPin1Callback0(int channel, boolean changed, boolean value, BrickletIO4V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO4V2InputPin2Callback0(int channel, boolean changed, boolean value, BrickletIO4V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO4V2InputPin3Callback0(int channel, boolean changed, boolean value, BrickletIO4V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO4V2OutputPin0Callback0(int channel, boolean value, BrickletIO4V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO4V2OutputPin1Callback0(int channel, boolean value, BrickletIO4V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO4V2OutputPin2Callback0(int channel, boolean value, BrickletIO4V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO4V2OutputPin3Callback0(int channel, boolean value, BrickletIO4V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO4V2InputPin0Getter0(boolean[] value, BrickletIO4V2Config cfg) {
        return value[0] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO4V2InputPin1Getter0(boolean[] value, BrickletIO4V2Config cfg) {
        return value[1] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO4V2InputPin2Getter0(boolean[] value, BrickletIO4V2Config cfg) {
        return value[2] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO4V2InputPin3Getter0(boolean[] value, BrickletIO4V2Config cfg) {
        return value[3] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO4V2OutputPin0Getter0(boolean[] value, BrickletIO4V2Config cfg) {
        return value[0] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO4V2OutputPin1Getter0(boolean[] value, BrickletIO4V2Config cfg) {
        return value[1] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO4V2OutputPin2Getter0(boolean[] value, BrickletIO4V2Config cfg) {
        return value[2] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO4V2OutputPin3Getter0(boolean[] value, BrickletIO4V2Config cfg) {
        return value[3] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO4V2MonoflopPin0Getter0(Monoflop value, BrickletIO4V2Config cfg) {
        return value.value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO4V2MonoflopPin1Getter0(Monoflop value, BrickletIO4V2Config cfg) {
        return value.value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO4V2MonoflopPin2Getter0(Monoflop value, BrickletIO4V2Config cfg) {
        return value.value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO4V2MonoflopPin3Getter0(Monoflop value, BrickletIO4V2Config cfg) {
        return value.value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO4V2EdgeCountPin0Getter0(long value, BrickletIO4V2Config cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformIO4V2EdgeCountPin1Getter0(long value, BrickletIO4V2Config cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformIO4V2EdgeCountPin2Getter0(long value, BrickletIO4V2Config cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformIO4V2EdgeCountPin3Getter0(long value, BrickletIO4V2Config cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }
}
