/* ***********************************************************
 * This file was automatically generated on 2019-09-04.      *
 *                                                           *
 * OpenHAB Bindings Version 2.1.23                           *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;
import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collections;
import java.util.function.Function;
import java.util.function.BiConsumer;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;

/**
 * Measures power, DC voltage and DC current up to 720W/36V/20A
 */
public class BrickletVoltageCurrentV2 extends Device {
	public final static int DEVICE_IDENTIFIER = 2105;
	public final static String DEVICE_DISPLAY_NAME = "Voltage/Current Bricklet 2.0";

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(DEVICE_DISPLAY_NAME, "voltagecurrentv2", DEVICE_IDENTIFIER, BrickletVoltageCurrentV2.class);

	public final static byte FUNCTION_GET_CURRENT = (byte)1;
	public final static byte FUNCTION_SET_CURRENT_CALLBACK_CONFIGURATION = (byte)2;
	public final static byte FUNCTION_GET_CURRENT_CALLBACK_CONFIGURATION = (byte)3;
	public final static byte FUNCTION_GET_VOLTAGE = (byte)5;
	public final static byte FUNCTION_SET_VOLTAGE_CALLBACK_CONFIGURATION = (byte)6;
	public final static byte FUNCTION_GET_VOLTAGE_CALLBACK_CONFIGURATION = (byte)7;
	public final static byte FUNCTION_GET_POWER = (byte)9;
	public final static byte FUNCTION_SET_POWER_CALLBACK_CONFIGURATION = (byte)10;
	public final static byte FUNCTION_GET_POWER_CALLBACK_CONFIGURATION = (byte)11;
	public final static byte FUNCTION_SET_CONFIGURATION = (byte)13;
	public final static byte FUNCTION_GET_CONFIGURATION = (byte)14;
	public final static byte FUNCTION_SET_CALIBRATION = (byte)15;
	public final static byte FUNCTION_GET_CALIBRATION = (byte)16;
	public final static byte FUNCTION_GET_SPITFP_ERROR_COUNT = (byte)234;
	public final static byte FUNCTION_SET_BOOTLOADER_MODE = (byte)235;
	public final static byte FUNCTION_GET_BOOTLOADER_MODE = (byte)236;
	public final static byte FUNCTION_SET_WRITE_FIRMWARE_POINTER = (byte)237;
	public final static byte FUNCTION_WRITE_FIRMWARE = (byte)238;
	public final static byte FUNCTION_SET_STATUS_LED_CONFIG = (byte)239;
	public final static byte FUNCTION_GET_STATUS_LED_CONFIG = (byte)240;
	public final static byte FUNCTION_GET_CHIP_TEMPERATURE = (byte)242;
	public final static byte FUNCTION_RESET = (byte)243;
	public final static byte FUNCTION_WRITE_UID = (byte)248;
	public final static byte FUNCTION_READ_UID = (byte)249;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_CURRENT = 4;
	private final static int CALLBACK_VOLTAGE = 8;
	private final static int CALLBACK_POWER = 12;

	public final static char THRESHOLD_OPTION_OFF = 'x';
	public final static char THRESHOLD_OPTION_OUTSIDE = 'o';
	public final static char THRESHOLD_OPTION_INSIDE = 'i';
	public final static char THRESHOLD_OPTION_SMALLER = '<';
	public final static char THRESHOLD_OPTION_GREATER = '>';
	public final static int AVERAGING_1 = 0;
	public final static int AVERAGING_4 = 1;
	public final static int AVERAGING_16 = 2;
	public final static int AVERAGING_64 = 3;
	public final static int AVERAGING_128 = 4;
	public final static int AVERAGING_256 = 5;
	public final static int AVERAGING_512 = 6;
	public final static int AVERAGING_1024 = 7;
	public final static int CONVERSION_TIME_140US = 0;
	public final static int CONVERSION_TIME_204US = 1;
	public final static int CONVERSION_TIME_332US = 2;
	public final static int CONVERSION_TIME_588US = 3;
	public final static int CONVERSION_TIME_1_1MS = 4;
	public final static int CONVERSION_TIME_2_116MS = 5;
	public final static int CONVERSION_TIME_4_156MS = 6;
	public final static int CONVERSION_TIME_8_244MS = 7;
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;

	private List<CurrentListener> listenerCurrent = new CopyOnWriteArrayList<CurrentListener>();
	private List<VoltageListener> listenerVoltage = new CopyOnWriteArrayList<VoltageListener>();
	private List<PowerListener> listenerPower = new CopyOnWriteArrayList<PowerListener>();

	public class CurrentCallbackConfiguration {
		public long period;
		public boolean valueHasToChange;
		public char option;
		public int min;
		public int max;

		public String toString() {
			return "[" + "period = " + period + ", " + "valueHasToChange = " + valueHasToChange + ", " + "option = " + option + ", " + "min = " + min + ", " + "max = " + max + "]";
		}
	}

	public class VoltageCallbackConfiguration {
		public long period;
		public boolean valueHasToChange;
		public char option;
		public int min;
		public int max;

		public String toString() {
			return "[" + "period = " + period + ", " + "valueHasToChange = " + valueHasToChange + ", " + "option = " + option + ", " + "min = " + min + ", " + "max = " + max + "]";
		}
	}

	public class PowerCallbackConfiguration {
		public long period;
		public boolean valueHasToChange;
		public char option;
		public int min;
		public int max;

		public String toString() {
			return "[" + "period = " + period + ", " + "valueHasToChange = " + valueHasToChange + ", " + "option = " + option + ", " + "min = " + min + ", " + "max = " + max + "]";
		}
	}

	public class Configuration {
		public int averaging;
		public int voltageConversionTime;
		public int currentConversionTime;

		public String toString() {
			return "[" + "averaging = " + averaging + ", " + "voltageConversionTime = " + voltageConversionTime + ", " + "currentConversionTime = " + currentConversionTime + "]";
		}
	}

	public class Calibration {
		public int voltageMultiplier;
		public int voltageDivisor;
		public int currentMultiplier;
		public int currentDivisor;

		public String toString() {
			return "[" + "voltageMultiplier = " + voltageMultiplier + ", " + "voltageDivisor = " + voltageDivisor + ", " + "currentMultiplier = " + currentMultiplier + ", " + "currentDivisor = " + currentDivisor + "]";
		}
	}

	public class SPITFPErrorCount {
		public long errorCountAckChecksum;
		public long errorCountMessageChecksum;
		public long errorCountFrame;
		public long errorCountOverflow;

		public String toString() {
			return "[" + "errorCountAckChecksum = " + errorCountAckChecksum + ", " + "errorCountMessageChecksum = " + errorCountMessageChecksum + ", " + "errorCountFrame = " + errorCountFrame + ", " + "errorCountOverflow = " + errorCountOverflow + "]";
		}
	}

	/**
	 * This listener is triggered periodically according to the configuration set by
	 * {@link BrickletVoltageCurrentV2#setCurrentCallbackConfiguration(long, boolean, char, int, int)}.
	 * 
	 * The parameter is the same as {@link BrickletVoltageCurrentV2#getCurrent()}.
	 */
	public interface CurrentListener extends DeviceListener {
		public void current(int current);
	}

	/**
	 * This listener is triggered periodically according to the configuration set by
	 * {@link BrickletVoltageCurrentV2#setVoltageCallbackConfiguration(long, boolean, char, int, int)}.
	 * 
	 * The parameter is the same as {@link BrickletVoltageCurrentV2#getVoltage()}.
	 */
	public interface VoltageListener extends DeviceListener {
		public void voltage(int voltage);
	}

	/**
	 * This listener is triggered periodically according to the configuration set by
	 * {@link BrickletVoltageCurrentV2#setPowerCallbackConfiguration(long, boolean, char, int, int)}.
	 * 
	 * The parameter is the same as {@link BrickletVoltageCurrentV2#getPower()}.
	 */
	public interface PowerListener extends DeviceListener {
		public void power(int power);
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletVoltageCurrentV2(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 0;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CURRENT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_CURRENT_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CURRENT_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_VOLTAGE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_VOLTAGE_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_VOLTAGE_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_POWER)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_POWER_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_POWER_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_CALIBRATION)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CALIBRATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_SPITFP_ERROR_COUNT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_WRITE_FIRMWARE_POINTER)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_WRITE_FIRMWARE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CHIP_TEMPERATURE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_RESET)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_WRITE_UID)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_READ_UID)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_CURRENT] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int current = (bb.getInt());

				for (CurrentListener listener: listenerCurrent) {
					listener.current(current);
				}
			}
		};

		callbacks[CALLBACK_VOLTAGE] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int voltage = (bb.getInt());

				for (VoltageListener listener: listenerVoltage) {
					listener.voltage(voltage);
				}
			}
		};

		callbacks[CALLBACK_POWER] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int power = (bb.getInt());

				for (PowerListener listener: listenerPower) {
					listener.power(power);
				}
			}
		};
	}

	/**
	 * Returns the current. The value is in mA
	 * and between -20000mA and 20000mA.
	 * 
	 * 
	 * If you want to get the value periodically, it is recommended to use the
	 * {@link BrickletVoltageCurrentV2.CurrentListener} listener. You can set the listener configuration
	 * with {@link BrickletVoltageCurrentV2#setCurrentCallbackConfiguration(long, boolean, char, int, int)}.
	 */
	public int getCurrent() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CURRENT, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int current = (bb.getInt());

		return current;
	}

	/**
	 * The period in ms is the period with which the {@link BrickletVoltageCurrentV2.CurrentListener} listener is triggered
	 * periodically. A value of 0 turns the listener off.
	 * 
	 * If the `value has to change`-parameter is set to true, the listener is only
	 * triggered after the value has changed. If the value didn't change
	 * within the period, the listener is triggered immediately on change.
	 * 
	 * If it is set to false, the listener is continuously triggered with the period,
	 * independent of the value.
	 * 
	 * It is furthermore possible to constrain the listener with thresholds.
	 * 
	 * The `option`-parameter together with min/max sets a threshold for the {@link BrickletVoltageCurrentV2.CurrentListener} listener.
	 * 
	 * The following options are possible:
	 * 
	 * \verbatim
	 *  "Option", "Description"
	 * 
	 *  "'x'",    "Threshold is turned off"
	 *  "'o'",    "Threshold is triggered when the value is *outside* the min and max values"
	 *  "'i'",    "Threshold is triggered when the value is *inside* or equal to the min and max values"
	 *  "'&lt;'",    "Threshold is triggered when the value is smaller than the min value (max is ignored)"
	 *  "'&gt;'",    "Threshold is triggered when the value is greater than the min value (max is ignored)"
	 * \endverbatim
	 * 
	 * If the option is set to 'x' (threshold turned off) the listener is triggered with the fixed period.
	 * 
	 * The default value is (0, false, 'x', 0, 0).
	 */
	public void setCurrentCallbackConfiguration(long period, boolean valueHasToChange, char option, int min, int max) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)22, FUNCTION_SET_CURRENT_CALLBACK_CONFIGURATION, this);

		bb.putInt((int)period);
		bb.put((byte)(valueHasToChange ? 1 : 0));
		bb.put((byte)option);
		bb.putInt(min);
		bb.putInt(max);

		sendRequest(bb.array());
	}

	/**
	 * Returns the listener configuration as set by {@link BrickletVoltageCurrentV2#setCurrentCallbackConfiguration(long, boolean, char, int, int)}.
	 */
	public CurrentCallbackConfiguration getCurrentCallbackConfiguration() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CURRENT_CALLBACK_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		CurrentCallbackConfiguration obj = new CurrentCallbackConfiguration();
		obj.period = IPConnection.unsignedInt(bb.getInt());
		obj.valueHasToChange = (bb.get()) != 0;
		obj.option = (char)(bb.get());
		obj.min = (bb.getInt());
		obj.max = (bb.getInt());

		return obj;
	}

	/**
	 * Returns the voltage. The value is in mV
	 * and between 0mV and 36000mV.
	 * 
	 * 
	 * If you want to get the value periodically, it is recommended to use the
	 * {@link BrickletVoltageCurrentV2.VoltageListener} listener. You can set the listener configuration
	 * with {@link BrickletVoltageCurrentV2#setVoltageCallbackConfiguration(long, boolean, char, int, int)}.
	 */
	public int getVoltage() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_VOLTAGE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int voltage = (bb.getInt());

		return voltage;
	}

	/**
	 * The period in ms is the period with which the {@link BrickletVoltageCurrentV2.VoltageListener} listener is triggered
	 * periodically. A value of 0 turns the listener off.
	 * 
	 * If the `value has to change`-parameter is set to true, the listener is only
	 * triggered after the value has changed. If the value didn't change
	 * within the period, the listener is triggered immediately on change.
	 * 
	 * If it is set to false, the listener is continuously triggered with the period,
	 * independent of the value.
	 * 
	 * It is furthermore possible to constrain the listener with thresholds.
	 * 
	 * The `option`-parameter together with min/max sets a threshold for the {@link BrickletVoltageCurrentV2.VoltageListener} listener.
	 * 
	 * The following options are possible:
	 * 
	 * \verbatim
	 *  "Option", "Description"
	 * 
	 *  "'x'",    "Threshold is turned off"
	 *  "'o'",    "Threshold is triggered when the value is *outside* the min and max values"
	 *  "'i'",    "Threshold is triggered when the value is *inside* or equal to the min and max values"
	 *  "'&lt;'",    "Threshold is triggered when the value is smaller than the min value (max is ignored)"
	 *  "'&gt;'",    "Threshold is triggered when the value is greater than the min value (max is ignored)"
	 * \endverbatim
	 * 
	 * If the option is set to 'x' (threshold turned off) the listener is triggered with the fixed period.
	 * 
	 * The default value is (0, false, 'x', 0, 0).
	 */
	public void setVoltageCallbackConfiguration(long period, boolean valueHasToChange, char option, int min, int max) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)22, FUNCTION_SET_VOLTAGE_CALLBACK_CONFIGURATION, this);

		bb.putInt((int)period);
		bb.put((byte)(valueHasToChange ? 1 : 0));
		bb.put((byte)option);
		bb.putInt(min);
		bb.putInt(max);

		sendRequest(bb.array());
	}

	/**
	 * Returns the listener configuration as set by {@link BrickletVoltageCurrentV2#setVoltageCallbackConfiguration(long, boolean, char, int, int)}.
	 */
	public VoltageCallbackConfiguration getVoltageCallbackConfiguration() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_VOLTAGE_CALLBACK_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		VoltageCallbackConfiguration obj = new VoltageCallbackConfiguration();
		obj.period = IPConnection.unsignedInt(bb.getInt());
		obj.valueHasToChange = (bb.get()) != 0;
		obj.option = (char)(bb.get());
		obj.min = (bb.getInt());
		obj.max = (bb.getInt());

		return obj;
	}

	/**
	 * Returns the power. The value is in mW
	 * and between 0mV and 720000mW.
	 * 
	 * 
	 * If you want to get the value periodically, it is recommended to use the
	 * {@link BrickletVoltageCurrentV2.PowerListener} listener. You can set the listener configuration
	 * with {@link BrickletVoltageCurrentV2#setPowerCallbackConfiguration(long, boolean, char, int, int)}.
	 */
	public int getPower() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_POWER, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int power = (bb.getInt());

		return power;
	}

	/**
	 * The period in ms is the period with which the {@link BrickletVoltageCurrentV2.PowerListener} listener is triggered
	 * periodically. A value of 0 turns the listener off.
	 * 
	 * If the `value has to change`-parameter is set to true, the listener is only
	 * triggered after the value has changed. If the value didn't change
	 * within the period, the listener is triggered immediately on change.
	 * 
	 * If it is set to false, the listener is continuously triggered with the period,
	 * independent of the value.
	 * 
	 * It is furthermore possible to constrain the listener with thresholds.
	 * 
	 * The `option`-parameter together with min/max sets a threshold for the {@link BrickletVoltageCurrentV2.PowerListener} listener.
	 * 
	 * The following options are possible:
	 * 
	 * \verbatim
	 *  "Option", "Description"
	 * 
	 *  "'x'",    "Threshold is turned off"
	 *  "'o'",    "Threshold is triggered when the value is *outside* the min and max values"
	 *  "'i'",    "Threshold is triggered when the value is *inside* or equal to the min and max values"
	 *  "'&lt;'",    "Threshold is triggered when the value is smaller than the min value (max is ignored)"
	 *  "'&gt;'",    "Threshold is triggered when the value is greater than the min value (max is ignored)"
	 * \endverbatim
	 * 
	 * If the option is set to 'x' (threshold turned off) the listener is triggered with the fixed period.
	 * 
	 * The default value is (0, false, 'x', 0, 0).
	 */
	public void setPowerCallbackConfiguration(long period, boolean valueHasToChange, char option, int min, int max) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)22, FUNCTION_SET_POWER_CALLBACK_CONFIGURATION, this);

		bb.putInt((int)period);
		bb.put((byte)(valueHasToChange ? 1 : 0));
		bb.put((byte)option);
		bb.putInt(min);
		bb.putInt(max);

		sendRequest(bb.array());
	}

	/**
	 * Returns the listener configuration as set by {@link BrickletVoltageCurrentV2#setPowerCallbackConfiguration(long, boolean, char, int, int)}.
	 */
	public PowerCallbackConfiguration getPowerCallbackConfiguration() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_POWER_CALLBACK_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		PowerCallbackConfiguration obj = new PowerCallbackConfiguration();
		obj.period = IPConnection.unsignedInt(bb.getInt());
		obj.valueHasToChange = (bb.get()) != 0;
		obj.option = (char)(bb.get());
		obj.min = (bb.getInt());
		obj.max = (bb.getInt());

		return obj;
	}

	/**
	 * Sets the configuration of the Voltage/Current Bricklet 2.0. It is
	 * possible to configure number of averages as well as
	 * voltage and current conversion time.
	 * 
	 * Averaging:
	 * 
	 * \verbatim
	 *  "Value", "Number of Averages"
	 * 
	 *  "0",    "1"
	 *  "1",    "4"
	 *  "2",    "16"
	 *  "3",    "64"
	 *  "4",    "128"
	 *  "5",    "256"
	 *  "6",    "512"
	 *  "&gt;=7",  "1024"
	 * \endverbatim
	 * 
	 * Voltage/Current conversion:
	 * 
	 * \verbatim
	 *  "Value", "Conversion time"
	 * 
	 *  "0",    "140µs"
	 *  "1",    "204µs"
	 *  "2",    "332µs"
	 *  "3",    "588µs"
	 *  "4",    "1.1ms"
	 *  "5",    "2.116ms"
	 *  "6",    "4.156ms"
	 *  "&gt;=7",  "8.244ms"
	 * \endverbatim
	 * 
	 * The default values are 3, 4 and 4 (64, 1.1ms, 1.1ms) for averaging, voltage
	 * conversion and current conversion.
	 */
	public void setConfiguration(int averaging, int voltageConversionTime, int currentConversionTime) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)11, FUNCTION_SET_CONFIGURATION, this);

		bb.put((byte)averaging);
		bb.put((byte)voltageConversionTime);
		bb.put((byte)currentConversionTime);

		sendRequest(bb.array());
	}

	/**
	 * Returns the configuration as set by {@link BrickletVoltageCurrentV2#setConfiguration(int, int, int)}.
	 */
	public Configuration getConfiguration() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Configuration obj = new Configuration();
		obj.averaging = IPConnection.unsignedByte(bb.get());
		obj.voltageConversionTime = IPConnection.unsignedByte(bb.get());
		obj.currentConversionTime = IPConnection.unsignedByte(bb.get());

		return obj;
	}

	/**
	 * Since the ADC and the shunt resistor used for the measurements
	 * are not perfect they need to be calibrated by a multiplier and
	 * a divisor if a very precise reading is needed.
	 * 
	 * For example, if you are expecting a current of 1000mA and you
	 * are measuring 1023mA, you can calibrate the Voltage/Current Bricklet
	 * by setting the current multiplier to 1000 and the divisor to 1023.
	 * The same applies for the voltage.
	 * 
	 * The calibration will be saved on the EEPROM of the Voltage/Current
	 * Bricklet and only needs to be done once.
	 */
	public void setCalibration(int voltageMultiplier, int voltageDivisor, int currentMultiplier, int currentDivisor) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)16, FUNCTION_SET_CALIBRATION, this);

		bb.putShort((short)voltageMultiplier);
		bb.putShort((short)voltageDivisor);
		bb.putShort((short)currentMultiplier);
		bb.putShort((short)currentDivisor);

		sendRequest(bb.array());
	}

	/**
	 * Returns the calibration as set by {@link BrickletVoltageCurrentV2#setCalibration(int, int, int, int)}.
	 */
	public Calibration getCalibration() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CALIBRATION, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Calibration obj = new Calibration();
		obj.voltageMultiplier = IPConnection.unsignedShort(bb.getShort());
		obj.voltageDivisor = IPConnection.unsignedShort(bb.getShort());
		obj.currentMultiplier = IPConnection.unsignedShort(bb.getShort());
		obj.currentDivisor = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Returns the error count for the communication between Brick and Bricklet.
	 * 
	 * The errors are divided into
	 * 
	 * * ACK checksum errors,
	 * * message checksum errors,
	 * * framing errors and
	 * * overflow errors.
	 * 
	 * The errors counts are for errors that occur on the Bricklet side. All
	 * Bricks have a similar function that returns the errors on the Brick side.
	 */
	public SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_SPITFP_ERROR_COUNT, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		SPITFPErrorCount obj = new SPITFPErrorCount();
		obj.errorCountAckChecksum = IPConnection.unsignedInt(bb.getInt());
		obj.errorCountMessageChecksum = IPConnection.unsignedInt(bb.getInt());
		obj.errorCountFrame = IPConnection.unsignedInt(bb.getInt());
		obj.errorCountOverflow = IPConnection.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Sets the bootloader mode and returns the status after the requested
	 * mode change was instigated.
	 * 
	 * You can change from bootloader mode to firmware mode and vice versa. A change
	 * from bootloader mode to firmware mode will only take place if the entry function,
	 * device identifier and CRC are present and correct.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int setBootloaderMode(int mode) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_BOOTLOADER_MODE, this);

		bb.put((byte)mode);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnection.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Returns the current bootloader mode, see {@link BrickletVoltageCurrentV2#setBootloaderMode(int)}.
	 */
	public int getBootloaderMode() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_BOOTLOADER_MODE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int mode = IPConnection.unsignedByte(bb.get());

		return mode;
	}

	/**
	 * Sets the firmware pointer for {@link BrickletVoltageCurrentV2#writeFirmware(int[])}. The pointer has
	 * to be increased by chunks of size 64. The data is written to flash
	 * every 4 chunks (which equals to one page of size 256).
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_WRITE_FIRMWARE_POINTER, this);

		bb.putInt((int)pointer);

		sendRequest(bb.array());
	}

	/**
	 * Writes 64 Bytes of firmware at the position as written by
	 * {@link BrickletVoltageCurrentV2#setWriteFirmwarePointer(long)} before. The firmware is written
	 * to flash every 4 chunks.
	 * 
	 * You can only write firmware in bootloader mode.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int writeFirmware(int[] data) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)72, FUNCTION_WRITE_FIRMWARE, this);

		for (int i = 0; i < 64; i++) {
			bb.put((byte)data[i]);
		}

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnection.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Sets the status LED configuration. By default the LED shows
	 * communication traffic between Brick and Bricklet, it flickers once
	 * for every 10 received data packets.
	 * 
	 * You can also turn the LED permanently on/off or show a heartbeat.
	 * 
	 * If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
	 */
	public void setStatusLEDConfig(int config) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_STATUS_LED_CONFIG, this);

		bb.put((byte)config);

		sendRequest(bb.array());
	}

	/**
	 * Returns the configuration as set by {@link BrickletVoltageCurrentV2#setStatusLEDConfig(int)}
	 */
	public int getStatusLEDConfig() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_STATUS_LED_CONFIG, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int config = IPConnection.unsignedByte(bb.get());

		return config;
	}

	/**
	 * Returns the temperature in °C as measured inside the microcontroller. The
	 * value returned is not the ambient temperature!
	 * 
	 * The temperature is only proportional to the real temperature and it has bad
	 * accuracy. Practically it is only useful as an indicator for
	 * temperature changes.
	 */
	public int getChipTemperature() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CHIP_TEMPERATURE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int temperature = (bb.getShort());

		return temperature;
	}

	/**
	 * Calling this function will reset the Bricklet. All configurations
	 * will be lost.
	 * 
	 * After a reset you have to create new device objects,
	 * calling functions on the existing ones will result in
	 * undefined behavior!
	 */
	public void reset() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_RESET, this);


		sendRequest(bb.array());
	}

	/**
	 * Writes a new UID into flash. If you want to set a new UID
	 * you have to decode the Base58 encoded UID string into an
	 * integer first.
	 * 
	 * We recommend that you use Brick Viewer to change the UID.
	 */
	public void writeUID(long uid) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_WRITE_UID, this);

		bb.putInt((int)uid);

		sendRequest(bb.array());
	}

	/**
	 * Returns the current UID as an integer. Encode as
	 * Base58 to get the usual string version.
	 */
	public long readUID() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_READ_UID, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long uid = IPConnection.unsignedInt(bb.getInt());

		return uid;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c' or 'd'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnection.string(bb, 8);
		obj.connectedUid = IPConnection.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Adds a Current listener.
	 */
	public void addCurrentListener(CurrentListener listener) {
		listenerCurrent.add(listener);
	}

	/**
	 * Removes a Current listener.
	 */
	public void removeCurrentListener(CurrentListener listener) {
		listenerCurrent.remove(listener);
	}

	/**
	 * Adds a Voltage listener.
	 */
	public void addVoltageListener(VoltageListener listener) {
		listenerVoltage.add(listener);
	}

	/**
	 * Removes a Voltage listener.
	 */
	public void removeVoltageListener(VoltageListener listener) {
		listenerVoltage.remove(listener);
	}

	/**
	 * Adds a Power listener.
	 */
	public void addPowerListener(PowerListener listener) {
		listenerPower.add(listener);
	}

	/**
	 * Removes a Power listener.
	 */
	public void removePowerListener(PowerListener listener) {
		listenerPower.remove(listener);
	}

    private final Logger logger = LoggerFactory.getLogger(BrickletVoltageCurrentV2.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletVoltageCurrentV2.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletVoltageCurrentV2Config cfg = (BrickletVoltageCurrentV2Config) config.as(BrickletVoltageCurrentV2Config.class);
        this.addCurrentListener((current) -> {if(true) {updateStateFn.accept("VoltageCurrentV2Current", transformVoltageCurrentV2CurrentCallback0(current, cfg));}});
		this.addVoltageListener((voltage) -> {if(true) {updateStateFn.accept("VoltageCurrentV2Voltage", transformVoltageCurrentV2VoltageCallback0(voltage, cfg));}});
		this.addPowerListener((power) -> {if(true) {updateStateFn.accept("VoltageCurrentV2Power", transformVoltageCurrentV2PowerCallback0(power, cfg));}});
        this.setConfiguration(cfg.averaging, cfg.voltageConversionTime, cfg.currentConversionTime);
		{
		BrickletVoltageCurrentV2CurrentConfig channelCfg = getChannelConfigFn.apply("VoltageCurrentV2Current").as(BrickletVoltageCurrentV2CurrentConfig.class);
		this.setCurrentCallbackConfiguration(channelCfg.updateInterval, true, 'x', 0, 0);
		}
		{
		BrickletVoltageCurrentV2VoltageConfig channelCfg = getChannelConfigFn.apply("VoltageCurrentV2Voltage").as(BrickletVoltageCurrentV2VoltageConfig.class);
		this.setVoltageCallbackConfiguration(channelCfg.updateInterval, true, 'x', 0, 0);
		}
		{
		BrickletVoltageCurrentV2PowerConfig channelCfg = getChannelConfigFn.apply("VoltageCurrentV2Power").as(BrickletVoltageCurrentV2PowerConfig.class);
		this.setPowerCallbackConfiguration(channelCfg.updateInterval, true, 'x', 0, 0);
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        BrickletVoltageCurrentV2Config cfg = (BrickletVoltageCurrentV2Config) config.as(BrickletVoltageCurrentV2Config.class);
        this.listenerCurrent.clear();
		this.listenerVoltage.clear();
		this.listenerPower.clear();
        this.setCurrentCallbackConfiguration(0, true, 'x', 0, 0);
		this.setVoltageCallbackConfiguration(0, true, 'x', 0, 0);
		this.setPowerCallbackConfiguration(0, true, 'x', 0, 0);
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletVoltageCurrentV2Config cfg = (BrickletVoltageCurrentV2Config) config.as(BrickletVoltageCurrentV2Config.class);
        List<String> result = new ArrayList<String>();
        result.add("VoltageCurrentV2Current");
		result.add("VoltageCurrentV2Voltage");
		result.add("VoltageCurrentV2Power");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "VoltageCurrentV2Voltage":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "VoltageCurrentV2Voltage"), "Measured Voltage", "Number:ElectricPotential").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:VoltageCurrentV2Voltage")).withDescription("The measured voltage between 0 and 36V.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(36)).withPattern("%.3f %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "VoltageCurrentV2Current":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "VoltageCurrentV2Current"), "Measured Current", "Number:ElectricCurrent").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:VoltageCurrentV2Current")).withDescription("The measured current between -20 and 20A.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(-20)).withMaximum(BigDecimal.valueOf(20)).withPattern("%.3f %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "VoltageCurrentV2Power":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "VoltageCurrentV2Power"), "Measured Power", "Number:Power").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:VoltageCurrentV2Power")).withDescription("The measured power between 0 and 720W.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(720)).withPattern("%.3f %unit%").withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Voltage/Current Bricklet 2.0").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.getId())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Measures power, DC voltage and DC current up to 720W/36V/20A").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("VoltageCurrentV2Current", new ChannelTypeUID("tinkerforge", "VoltageCurrentV2Current")).build(), new ChannelDefinitionBuilder("VoltageCurrentV2Voltage", new ChannelTypeUID("tinkerforge", "VoltageCurrentV2Voltage")).build(), new ChannelDefinitionBuilder("VoltageCurrentV2Power", new ChannelTypeUID("tinkerforge", "VoltageCurrentV2Power")).build())).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:voltagecurrentv2":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("averaging", Type.INTEGER).withDefault("3").withDescription("Configures the number of samples to average over.").withLabel("Averaging").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "1"), new ParameterOption("1", "4"), new ParameterOption("2", "16"), new ParameterOption("3", "64"), new ParameterOption("4", "128"), new ParameterOption("5", "256"), new ParameterOption("6", "512"), new ParameterOption("7", "1024"))).build(), ConfigDescriptionParameterBuilder.create("voltageConversionTime", Type.INTEGER).withDefault("4").withDescription("Configures the voltage conversion time.").withLabel("Voltage Conversion Time").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "140µs"), new ParameterOption("1", "204µs"), new ParameterOption("2", "332µs"), new ParameterOption("3", "588µs"), new ParameterOption("4", "1.1ms"), new ParameterOption("5", "2.116ms"), new ParameterOption("6", "4.156ms"), new ParameterOption("7", "8.244ms"))).build(), ConfigDescriptionParameterBuilder.create("currentConversionTime", Type.INTEGER).withDefault("4").withDescription("Configures the current conversion time.").withLabel("Current Conversion Time").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "140µs"), new ParameterOption("1", "204µs"), new ParameterOption("2", "332µs"), new ParameterOption("3", "588µs"), new ParameterOption("4", "1.1ms"), new ParameterOption("5", "2.116ms"), new ParameterOption("6", "4.156ms"), new ParameterOption("7", "8.244ms"))).build()), Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals")));
            case "channel-type:tinkerforge:VoltageCurrentV2Voltage":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build()));
            case "channel-type:tinkerforge:VoltageCurrentV2Current":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build()));
            case "channel-type:tinkerforge:VoltageCurrentV2Power":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build()));
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String value, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletVoltageCurrentV2Config cfg = (BrickletVoltageCurrentV2Config) config.as(BrickletVoltageCurrentV2Config.class);
        switch(value) {
            case "VoltageCurrentV2Current": {
                   BrickletVoltageCurrentV2CurrentConfig channelCfg = channelConfig.as(BrickletVoltageCurrentV2CurrentConfig.class);
                   updateStateFn.accept(value, transformVoltageCurrentV2CurrentGetter0(this.getCurrent(), cfg));
                   return;
               }
            case "VoltageCurrentV2Voltage": {
                   BrickletVoltageCurrentV2VoltageConfig channelCfg = channelConfig.as(BrickletVoltageCurrentV2VoltageConfig.class);
                   updateStateFn.accept(value, transformVoltageCurrentV2VoltageGetter0(this.getVoltage(), cfg));
                   return;
               }
            case "VoltageCurrentV2Power": {
                   BrickletVoltageCurrentV2PowerConfig channelCfg = channelConfig.as(BrickletVoltageCurrentV2PowerConfig.class);
                   updateStateFn.accept(value, transformVoltageCurrentV2PowerGetter0(this.getPower(), cfg));
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", value);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletVoltageCurrentV2Config cfg = (BrickletVoltageCurrentV2Config) config.as(BrickletVoltageCurrentV2Config.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformVoltageCurrentV2CurrentCallback0(int current, BrickletVoltageCurrentV2Config cfg) {
        return new QuantityType<>(current / 1000.0, SmartHomeUnits.AMPERE);
    }
	    private org.eclipse.smarthome.core.types.State transformVoltageCurrentV2VoltageCallback0(int voltage, BrickletVoltageCurrentV2Config cfg) {
        return new QuantityType<>(voltage / 1000.0, SmartHomeUnits.VOLT);
    }
	    private org.eclipse.smarthome.core.types.State transformVoltageCurrentV2PowerCallback0(int power, BrickletVoltageCurrentV2Config cfg) {
        return new QuantityType<>(power / 1000.0, SmartHomeUnits.WATT);
    }
	    private org.eclipse.smarthome.core.types.State transformVoltageCurrentV2CurrentGetter0(int value, BrickletVoltageCurrentV2Config cfg) {
        return new QuantityType<>(value / 1000.0, SmartHomeUnits.AMPERE);
    }
	    private org.eclipse.smarthome.core.types.State transformVoltageCurrentV2VoltageGetter0(int value, BrickletVoltageCurrentV2Config cfg) {
        return new QuantityType<>(value / 1000.0, SmartHomeUnits.VOLT);
    }
	    private org.eclipse.smarthome.core.types.State transformVoltageCurrentV2PowerGetter0(int value, BrickletVoltageCurrentV2Config cfg) {
        return new QuantityType<>(value / 1000.0, SmartHomeUnits.WATT);
    }
}
